
/* nxlcau71.h			*/
/* header for lcau71.c		*/
/* 12 May 1989			*/

# define COLGRAF      4 	/* graph resolution			*/
# define T80X25       3 	/* text resolution			*/
# define WHCYMAG      1 	/* color quad for normal screen		*/
# define YELREGR      2 	/* color quad for alternative screen	*/
# define TRR	     16 	/* row showing totalistic rule number  	*/
# define TRC	     56  	/* column for totalistic rule number	*/
# define XRR	     12 	/* row displaying totalistic rule	*/
# define XRC	     56 	/* column for totalistic rule		*/
# define AL         320  	/* array length (screen width)		*/
# define SL          40	 	/* short array length			*/
# define KK           7  	/* number of states per cell		*/
# define RR	      3 	/* length of neighborhood = 2r+1	*/ 
# define DS  (KK*KK*KK)  	/* KK^RR (distinct neighborhoods)	*/
# define DN     (KK*KK)	 	/* number of distinct de Bruijn nodes	*/
# define PDN	   1296  	/* nodes in pair diagram = KK^4r	*/
# define SDN	    512  	/* nodes in subset diagram = 2^(KK^2r)	*/
# define DDN	   2401 	/* maximum nodes any de Bruijn diagram	*/
# define TS (RR*(KK-1)+1)  	/* distinct sums w/totalistic rule	*/
# define SS ((RR-1)*(KK-1)+1) 	/* distinct sums w/stotalistic rule	*/
# define BD	     11  	/* maximum degree of b.p.		*/

# define RSYM		12	/* number of rule symmetries = 2*k!	*/
# define WNML	     173	/* arry size to hold hex wolfram number */

# define CCY          3		/* circumference of max length cycle	*/
# define XCY	   3125		/* max number of cycles = KK^CCY	*/

# define XAN	     35		/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define AV	(KK*KK)

# define CLEN 300	/* buffer length for rec source     */
# define PLEN 900	/* buffer length for rec object     */
# define XLEN 128	/* buffer length for rec predefined */
# define NY    24

typedef union birular {int one[KK*KK*KK]; int three[KK][KK][KK];} birular;
typedef union parneih  {int one[K4];
			int two[K2][K2];
			int four[KK][KK][KK][KK];
			} parneih;
typedef union twoparn  {int one[K8];
			int two[K4][K4];
			int eight[KK][KK][KK][KK][KK][KK][KK][KK];
			} twoparn;

/* end nxlcau71.h */
