
/* nxrijn71.c						*/
/* program for LCA71 option 'd'				*/
/* display de Bruijn diagram - 1st, 2nd, & 3rd gen	*/
/* Harold V. McIntosh, 20 February 1988			*/
/* 21 February 1988 - add j0=i0; to Pass 4's		*/
/* 26 September 1989 - show evolution of periodic conf	*/
/* 2 October 1989 - cycl41.c incorporated into rijn41.c	*/
/* 20 November 1989 - eliminate loop from kwait		*/
/* 10 July 1994 - adapt to NeXT				*/

/*	Copyright (C) 1987	*/
/*	Copyright (C) 1988	*/
/*	Copyright (C) 1989	*/
/*	Copyright (C) 1994	*/
/*	Harold V. McIntosh	*/

# include "nxlcau71.h"
# include "nxrijn71.h"
# include <math.h>
# import  <dpsclient/psops.h>
# import  <appkit/graphics.h>

extern NXColor colst[KK];

extern char arr1[AL];
extern char ascrule[KK][KK][KK];		/* ASCII transition values */
extern int  binrule[KK][KK][KK];
extern int  ix0, iy0;				/* origin for pen moves */

# define JX  0.50  /* x-center, de Bruijn diagram	*/
# define JY  0.50  /* y-center, de Bruijn diagram	*/
# define RI 0.425  /* inner radius, de Bruijn diagram	*/
# define RO 0.475  /* outer radius, de Bruijn diagram	*/

extern int    dd;		/* # points in de Bruijn ring	*/
extern double dcntr[][2];
extern int    dbtag[];
extern int    dbno;

extern char               aarry[KK][KK][KK];
extern char           barry[KK][KK][KK][KK][KK];

long random();


/* edit the de Bruijn diagram		*/
/* g = number of generation (0==2nd)	*/
/* s = shift distance (g==0)		*/
void edijn(g,s,p,r) int g, s, p, r; {
   switch(g+'a') {
    case 'A': xpass1(s); break;
    case 'B': ypass1(s); break;
//    case 'C': zpass1(s); break;

    case 'a': switch (s+'g') {
//    case 'c': dpass1(13,p,r); break;
//    case 'd': cpass1(7,p,r); break;
    case 'e': bpass1(5,p,r); break;
    case 'f': apass1(2,p,r); break;
    case 'g': apass1(1,p,r); break;
    case 'h': apass1(0,p,r); break;
    case 'i': bpass1(6,p,r); break;
//    case 'j': cpass1(8,p,r); break;
//    case 'k': dpass1(14,p,4); break;
    default: break;} break;

    case 'b': switch (s+'g') {
//    case 'c': dpass1(11,p,r); break;
//    case 'd': cpass1(7,p,r); break;
    case 'e': bpass1(0,p,r); break;
    case 'f': bpass1(1,p,r); break;
    case 'g': bpass1(2,p,r); break;
    case 'h': bpass1(3,p,r); break;
    case 'i': bpass1(4,p,r); break;
//    case 'j': cpass1(8,p,r); break;
//    case 'k': dpass1(12,p,r); break;
    default: break;} break;

    case 'c': switch (s+'g') {
//    case 'c': dpass1(9,p,r); break;
//    case 'd': cpass1(0,p,r); break;
//    case 'e': cpass1(1,p,r); break;
//    case 'f': cpass1(2,p,r); break;
//    case 'g': cpass1(3,p,r); break;
//    case 'h': cpass1(4,p,r); break;
//    case 'i': cpass1(5,p,r); break;
//    case 'j': cpass1(6,p,r); break;
//    case 'k': dpass1(10,p,r); break;
    default: break;} break;


    default: break;
    } /* end switch */
}

/* clear edijn screen and set up menu */
void clijn() {
  videocursor(0,0,0);
//  hscrrul();
  videocursor(0,3,0);
  printf("de Bruijn ring \n");
  printf("OPQabcRST (x,1)\n");
  printf("UVdefghWX (x,2)\n");
  printf("YijklmnoZ (x,3)\n");
  printf("pqrstuvwx (x,4)\n");
  printf("y - cycles 1-8 \n");
  printf(" 123456-diagram\n");
  printf("  ABCD  all 1's\n");
  printf("  EFGH 0*1*2*3*\n");
  printf("  IJKL  full n*\n");
  printf("+-  -   palette\n");
  printf("<?> cll,hlp,clr\n");
  printf("<cr>  - exit   \n\n");
}

/* edit the Pass 4 and Pass 5 shift displays */
void edshif(arry,ix,n,p4,p5)
char *arry;
int  *ix, n;
void (*p4)(), (*p5)(); {
char c;
int  i, j, k;
while (0<1) {
  c=kbdin();
  if (c=='\015') break;
  switch (c) {
    case 'p':
      return;
    case 'r':
      for (j=0; j<100; j++) {
        i=random();
        for (k=0; k<3; k++) {ix[k]=i%KK; i/=KK;}
        (*p5)(arry,ix);
        }
      break;
    case 's':
      for (i=0; i<n; i++) ix[i]=0;
      do {
        (*p5)(arry,ix);
        if (kbdst()) {kbdin(); break;}
        for (i=n; i>0; i--) {
	  ix[i-1]++;
	  if (ix[i-1]==KK) {ix[i-1]=0; ix[i]++;} else break;
	  }} while (i>0);
      videocursor(0,2,0); printf("           ");
      break;
    default: break;
    }}
}

/* edit the Pass 4 and Pass 5 shift displays */
void edshf(g,s,c) int g, s, c; {
    switch(shflev(g,s)) {
    case 0: apass5(c); break;
    case 1: bpass5(c); break;
//    case 2: cpass5(c); break;
//    case 3: dpass5(c); break;
    default: break;
    } /* end switch */
}

/* edit the Pass 5 constant displays */
void edshc(g,c) int g, c; {
  switch(g) {
    case 0: apass5(c); break;
    case 1: bpass5(c); break;
//    case 2: cpass5(c); break;
//    case 3: dpass5(c); break;
    default: break;}
}

/* edit the Pass 6 shift calculations */
void edshg(g,s) int g, s; {
  switch(shflev(g,s)) {
    case 0: apass6(); break;
    case 1: bpass6(); break;
//    case 2: cpass6(); break;
//    case 3: dpass6(); break;
    default: break;}
}

/* edit the Pass 6 shift calculations */
void edcst(s) int s; {
  switch(s) {
    case 0: apass6(); break;
    case 1: bpass6(); break;
//    case 2: cpass6(); break;
//    case 3: dpass6(); break;
    default: break;}
}

/* find the level of de Bruijn diagram appropriate to g, s  */
int shflev(g,s) int g, s; {int  i;
  i=s<0?-s:s;
  if (i<=g+1) i=g; else i=i-1;
  return i;
}

/* increment ix */ 
void incix(ix,n) int *ix, n; {int i; 
  for (i=0; i<n; i++) if (ix[i]==0) {ix[i]=1; return;} else ix[i]=0;
}

/* selected node in ix */ 
void nodix(ix,n) int *ix, n; {int i, j; 
  j=dbno;
  for (i=0; i<n; i++) {ix[n-i-1]=j%KK; j/=KK;}
}

/* random number in ix */ 
void ranix(ix,n) int *ix, n; {int i, j; 
  j=random();
  for (i=0; i<n; i++) {ix[i]=j%KK; j/=KK;}
}

/* clear ix */ 
void zerix(ix,n) int *ix, n; {int i; for (i=0; i<n; i++) ix[i]=0;}

/* find index of nearest center to x, y (de Bruijn) */
int nearest(x,y) double x, y; {int i, k; double ex, wy, r, p;
k=0; p=500000.0;
for (i=0; i<dd; i++) {
  if (dbtag[i]==1) {
    ex=x-dcntr[i][0];
    wy=y-dcntr[i][1];
    r=ex*ex+wy*wy;
    if (r<p) {p=r; k=i;}
    }
  }
return k;
}

/* generate a de Bruijn diagram with m nodes, n links per node, color l */
void ijn(m,n,l) int m, n, l; {
int    i, j;
double ii, jj, nn, x, y, t, h;
// printf("ijn (m,n,l) - %3d, %3d, %3d\n",m,n,l);
nn=(double)(n);
t=6.28318/((double)(m));
h=0.5*t;
for (i=0; i<m; i++) {
  ii=(double)(i);
  for (j=0; j<n; j++) {
    jj=(double)(j);
    x=JX-RO*sin(ii*t+h);
    y=JY-RO*cos(ii*t+h);
    videoline(x,y,0);
    x=JX-RO*sin((nn*ii+jj)*t+h);
    y=JY-RO*cos((nn*ii+jj)*t+h);
    videoline(x,y,l);
    }
  }
}

/* insert a link into a de Bruijn diagram */
/* u - initial vertex     */
/* v - terminal vertex    */
/* l - color of link	  */

void lijnk(u,v,l) int u, v; int l; {
char   s[10];
double x, y, ex, wy, eks, wye, dx, dy, r, w, t, sx, sy;

	if (l<KK) NXSetColor(colst[l]); else PSsetgray(NX_BLACK);
	r=10.3;
	w=3.33;
	ex=dcntr[u][0];
	wy=dcntr[u][1];
	x=dcntr[v][0];
	y=dcntr[v][1];
	dx=x-ex;
	dy=y-wy;
	t=atan2(dy,dx);
	sx=-w*sin(t);
	sy= w*cos(t);
	eks=x-r*cos(t)+sx;
	wye=y-r*sin(t)+sy;
	PSmoveto(ex+sx,wy+sy);
	PSlineto(eks,wye);
	PSlineto(eks-0.1*dx+0.05*dy,wye-0.1*dy-0.05*dx);
	PSlineto(eks-0.1*dx-0.05*dy,wye-0.1*dy+0.05*dx);
	PSlineto(eks,wye);
	PSstroke();

	PSmoveto(x+10.3,y);
	NXSetColor(colst[v%KK]);
	PSarc(x, y, 10.3, 0.0, 360.0);
	PSstroke();

   PSsetgray(NX_BLACK); 

   ex=dcntr[u][0];
   wy=dcntr[u][1];
   PSmoveto(ex-10.0,wy+5.0);
	sprintf(s,"%3d",u);
   PSshow(s);

   ex=dcntr[v][0];
   wy=dcntr[v][1];
   PSmoveto(ex-10.0,wy+5.0);
	sprintf(s,"%3d",v);
   PSshow(s);
   PSstroke();

}

/* generate a de Bruijn diagram showing ancestors of state k in color l */
void sijn(k,l) int k, l; {
int    i0, i1, i2;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  if (k==ascrule[i0][i1][i2]-'0') lijnk(i1+KK*i0,i2+KK*i1,l);
}

/* generate a de Bruijn diagram showing the (1,k) links in color l */
void zijn(m,k,l) int m, k, l; {
int    i, i0, i1, i2;
double th, x, y, t, h;
t=6.28318/((double)(m));
h=0.5*t;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
  i=ascrule[i0][i1][i2]-'0';
  if ((k==0 && i==i0) || (k==1 && i==i1) || (k==2 && i==i2)) {
    th=((double)(i0*KK+i1))*t+h;
    x=JX-RI*sin(th);
    y=JY-RI*cos(th);
    videoline(x,y,0);
    th=((double)(i1*KK+i2))*t+h;
    x=JX-RO*sin(th);
    y=JY-RO*cos(th);
    videoline(x,y,l);
    }	/* end if    */
  }}}   /* end for's */
}	/* end zijn  */

/* plot graph on video screen 		   */
/* move pen from present position to (x,y) */
/* raised if l=0; color l if l>0	   */
void videoline(x,y,l) double x, y; int l; {
// printf("x,y,l = %6.3f, %6.3f, %3d.\n",x,y,l);
if (l==0) PSmoveto(400.0*x,400.0*y);
else PSlineto(400.0*x,400.0*y);
}

int permut(k,n) int k, n; {
  switch (n) {
    case 0: break;
    case 1: k=(k+1)%KK; break;
    case 2: k=(KK+k-1)%KK; break;
    case 3: if (k==1) k=2; else if (k==2) k=1; break;
    case 4: if (k==2) k=0; else if (k==0) k=2; break;
    case 5: if (k==0) k=1; else if (k==1) k=0; break;
    default: break;}
  return k;
}

/* - - - - - - - - d e   B r u i j n - - - - - - - - - - - - - - - - - - */

/* ONE21.C */

/* Pass 1a analyzes all the configurations which fulfil (-1+l,1) */
void apass1(l,p,r) int l, p, r; {
int  ix[RR], m;
asctobin();
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++) {
//  m=permut(ix[l],p);
  m=ix[l];
  aarry[ix[0]][ix[1]][ix[2]]=binrule[ix[0]][ix[1]][ix[2]]==m?'Y':'N';
  }
if (r) {apass2i(); apass2o();}
}

/* Pass 1x analyzes all the configurations mapping into a constant */
void xpass1(l) int l; {
int  ix[RR];
asctobin();
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++) {
  aarry[ix[0]][ix[1]][ix[2]]=binrule[ix[0]][ix[1]][ix[2]]==l?'Y':'N';
  }
apass2i();
apass2o();
}

/* Pass 2i flags all links with an incoming arrow */
/* Pass 2o flags all links with an outgoing arrow */
/* Then pass 3 discards all unflagged links */
/* Passes 2 and 3 alternate until no change is observed */

void apass2i() {int i,j,k,m;
do {
for (i=0; i<KK; i++)
for (j=0; j<KK; j++)
for (k=0; k<KK; k++) {
if ((aarry[i][j][k]&0x5F)=='Y') {for (m=0; m<KK; m++) aarry[j][k][m]|=0x20;}
}
 } while (apass3()!=0); }

void apass2o() {int i,j,k,m;
do {
for (i=0; i<KK; i++)
for (j=0; j<KK; j++)
for (k=0; k<KK; k++) {
if ((aarry[i][j][k]&0x5F)=='Y') {for (m=0; m<KK; m++) aarry[m][i][j]|=0x20;}
}
 } while (apass3()!=0); }

/* Pass 3 - erase flags, mark survivors, count changes */

int apass3() {int i,j,k,l;
l=0;
for (i=0; i<KK; i++)
for (j=0; j<KK; j++)
for (k=0; k<KK; k++) {
  switch (aarry[i][j][k]) {
    case 'y': aarry[i][j][k]='Y'; break;
    case 'Y': aarry[i][j][k]='N'; l=1; break;
    case 'n': case 'N': aarry[i][j][k]='N'; break;
    default: break; }
}
return l;
}

/* Pass4 - print loops which remain */
void apass4() {
int i0, i1, i2;
int j0, j1, j2;
int k, l, m;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
j0=i0; j1=i1; j2=i2; l=0; m=0;
do {
        if (aarry[0][j1][j2]=='Y')
    {aarry[0][j1][j2]='y';
    k=j2; j2=j1; j1=0; m=1;}
  else {if (aarry[1][j1][j2]=='Y')
    {aarry[1][j1][j2]='y';
    k=j2; j2=j1; j1=1; m=1;}
  else {l=1; if (m==1) {j0=j1; j1=j2; j2=k;} }}
  } while (l==0);
l=0; 
m=0;
do {
        if (aarry[j0][j1][0]=='y')
   {aprf(j0,j1,0);
   aarry[j0][j1][0]='N';
   j0=j1; j1=0; m=1;}
  else {if (aarry[j0][j1][1]=='y')
   {aprf(j0,j1,1);
   aarry[j0][j1][1]='N';
   j0=j1; j1=1; m=1;}
  else {l=1;}}
  } while (l==0);
l=0;
do {
        if (aarry[j0][j1][0]=='Y')
   {aprf(j0,j1,0);
   aarry[j0][j1][0]='N';
   j0=j1; j1=0; m=1;}
  else {if (aarry[j0][j1][1]=='Y')
   {aprf(j0,j1,1);
   aarry[j0][j1][1]='N';
   j0=j1; j1=1; m=1;}
  else l=1;}
  } while (l==0);
}}}
}

/* print one link of the de Bruijn diagram */
void aprf(i,j,k) int i, j, k; {
// printf("%1d",i);
// printf("%1d",j);
// printf("-");
// printf("%1d",k);
// printf("  ");
lijnk(i*KK+j,j*KK+k,3);
}

/* Pass 5 - show evolution of sample loops */
void apass5(c) char c; {
int i0, i1, i2;
int j1;
int hl;
int b[KK], irry[RR], i, j, k, l;
  switch (c) {
    case 'z': zerix(irry,RR); break;
    case 'r': ranix(irry,RR); break;
    case 'n': nodix(irry,RR-1);
	i0=irry[0]; i1=irry[1];
	for (i=j=0; j<KK; j++) if (aarry[i0][i1][j]=='Y') {b[i]=j; i++;}
	if (i==0) return;
	l=0; if (i>1) l=random()%i;
	irry[2]=b[l];
	break;
    case 'i': incix(irry,RR); break;
    default:  zerix(irry,RR); break;}
  i0=irry[0]; i1=irry[1]; i2=irry[2];
for (k=0; k<9; k++) {
  if (aarry[i0][i1][i2]=='Y') break;
  incix(irry,3);
  i0=irry[0]; i1=irry[1]; i2=irry[2];
  }
hl=AL/2;
arr1[hl-1]=i0;
arr1[hl]=i1;
arr1[hl+1]=i2;
j1=i1;
for (k=hl-2; k>=0; k--) {
  for (i=j=0; j<KK; j++) if (aarry[j][i0][i1]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  i1=i0; i0=arr1[k]=b[l];
  }
i1=j1;
for (k=hl+2; k<AL; k++) {
  for (i=j=0; j<KK; j++) if (aarry[i1][i2][j]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  i1=i2; i2=arr1[k]=b[l];
  }
}

void apass6() {int i, j, k, i0, i1, i2;
k=0;
for (i=0; i<DDN; i++) dbtag[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
  i=i0*KK+i1;
  j=i1*KK+i2;
  if(aarry[i0][i1][i2]=='Y') {
	dbtag[i]=1;
	dbtag[j]=1;
	lijnk(i,j,3);
	k++;
	}
  }
printf("nuclear size apass6 = %10d\n",k);
}

/* TWO21.C */

/* mark sequences conforming to (-2+l,2) */
void bpass1(l,p,r) int l, p, r; {
int ix[RR+2], jx[RR], kx;
int i, m, n;
asctobin();
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++)
for (ix[3]=0; ix[3]<KK; ix[3]++)
for (ix[4]=0; ix[4]<KK; ix[4]++) {
  for (i=0; i<3; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  kx=binrule[jx[0]][jx[1]][jx[2]];
  if (l<5)  {m=ix[l]; n=kx;}
  if (l==5) {m=ix[0]; n=jx[1];}
  if (l==6) {m=ix[4]; n=jx[1];}
  barry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]]=m==permut(n,p)?'Y':'N';
  }
if (r) {bpass2i(); bpass2o();}
}

/* Pass 1y analyzes all the configurations mapping into a constant */
void ypass1(l) int l; {
int ix[RR+2], jx[RR], kx;
int i;
asctobin();
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++)
for (ix[3]=0; ix[3]<KK; ix[3]++)
for (ix[4]=0; ix[4]<KK; ix[4]++) {
  for (i=0; i<3; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  kx=binrule[jx[0]][jx[1]][jx[2]];
  barry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]]=kx==l?'Y':'N';
  }
bpass2i();
bpass2o();
}

/* Passs 2i flags links which have an incoming arrow */
void bpass2i() {
int i0, i1, i2, i3, i4, m;
do {
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
if ((barry[i0][i1][i2][i3][i4]&0x5F)=='Y')
 {for (m=0; m<KK; m++) barry[i1][i2][i3][i4][m]|=0x20;}
}
} while (bpass3()!=0); }

/* Passs 2o flags links which have an outgoing arrow */
void bpass2o() {
int i0, i1, i2, i3, i4, m;
do {
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
if ((barry[i0][i1][i2][i3][i4]&0x5F)=='Y')
 {for (m=0; m<KK; m++) barry[m][i0][i1][i2][i3]|=0x20;}
}
} while (bpass3()!=0); }

/*  Pass 3 erases flags, marks survivors, counts changes */
int bpass3() {
int i0, i1, i2, i3, i4, l;
l=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
switch (barry[i0][i1][i2][i3][i4]) {
    case 'y': barry[i0][i1][i2][i3][i4]='Y'; break;
    case 'Y': barry[i0][i1][i2][i3][i4]='N'; l=1; break;
    case 'n': case 'N': barry[i0][i1][i2][i3][i4]='N'; break;
    default: break; }
}
return l;
}

/* Pass 4 prints loops which remain */
void bpass4() {
int i0, i1, i2, i3, i4;
int j0, j1, j2, j3, j4, k, l, m;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
j0=i0; j1=i1; j2=i2; j3=i3; j4=i4; l=0; m=0;
do {
        if (barry[0][j1][j2][j3][j4]=='Y')
    {barry[0][j1][j2][j3][j4]='y';
    k=j4; j4=j3; j3=j2; j2=j1; j1=0; m=1;}
  else {if (barry[1][j1][j2][j3][j4]=='Y')
    {barry[1][j1][j2][j3][j4]='y';
    k=j4; j4=j3; j3=j2; j2=j1; j1=1; m=1;}
  else {l=1; if (m==1) {j0=j1; j1=j2; j2=j3; j3=j4; j4=k;} }}
  } while (l==0);
l=0; 
m=0;
do {
        if (barry[j0][j1][j2][j3][0]=='y')
   {bprf(j0,j1,j2,j3,0);
   barry[j0][j1][j2][j3][0]='N';
   j0=j1; j1=j2; j2=j3; j3=0; m=1;}
  else {if (barry[j0][j1][j2][j3][1]=='y')
   {bprf(j0,j1,j2,j3,1);
   barry[j0][j1][j2][j3][1]='N';
   j0=j1; j1=j2; j2=j3; j3=1; m=1;}
  else {l=1;}}
  } while (l==0);
l=0;
do {
        if (barry[j0][j1][j2][j3][0]=='Y')
   {bprf(j0,j1,j2,j3,0);
   barry[j0][j1][j2][j3][0]='N';
   j0=j1; j1=j2; j2=j3; j3=0; m=1;}
  else {if (barry[j0][j1][j2][j3][1]=='Y')
   {bprf(j0,j1,j2,j3,1);
   barry[j0][j1][j2][j3][1]='N';
   j0=j1; j1=j2; j2=j3; j3=1; m=1;}
  else l=1;}
  } while (l==0);
}
}

/* print one of the links in a chain */
void bprf(i0,i1,i2,i3,i4) int i0, i1, i2, i3, i4; {
// printf("%1d",i0);
// printf("%1d",i1);
// printf("%1d",i2);
// printf("%1d",i3);
// printf("-");
// printf("%1d",i4);
// printf(" ");
lijnk(((i0*KK+i1)*KK+i2)*KK+i3,((i1*KK+i2)*KK+i3)*KK+i4,3);
}

/* Pass 5 - show evolution of sample loops */
void bpass5(c) char c; {
int i0, i1, i2, i3, i4;
int j1, j2, j3;
int hl;
int b[RR], irry[RR+2], i, j, k, l;
  switch (c) {
    case 'z': zerix(irry,RR+2); break;
    case 'r': ranix(irry,RR+2); break;
    case 'n': nodix(irry,RR+1);
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3];
  for (i=j=0; j<KK; j++) if (barry[i0][i1][i2][i3][j]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  irry[4]=b[l];
  break;
    case 'i': incix(irry,RR+2); break;
    default:  zerix(irry,RR+2); break;}
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3]; i4=irry[4];
for (k=0; k<81; k++) {
  if (barry[i0][i1][i2][i3][i4]=='Y') break;
  incix(irry,RR+2);
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3]; i4=irry[4];
  }
hl=AL/2;
arr1[hl-2]=i0;
arr1[hl-1]=i1;
arr1[hl]=i2;
arr1[hl+1]=i3;
arr1[hl+2]=i4;
j1=i1; j2=i2; j3=i3;
for (k=hl-3; k>=0; k--) {
  for (i=j=0; j<KK; j++) if (barry[j][i0][i1][i2][i3]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  i3=i2; i2=i1; i1=i0; i0=arr1[k]=b[l];
        k=k;
  }
i1=j1; i2=j2; i3=j3;
for (k=hl+3; k<AL; k++) {
  for (i=j=0; j<KK; j++) if (barry[i1][i2][i3][i4][j]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  i1=i2; i2=i3; i3=i4; i4=arr1[k]=b[l];
         i=i;
  }
}

void bpass6() {int i, j, k, i0, i1, i2, i3, i4;
k=0;
for (i=0; i<DDN; i++) dbtag[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
  i=((i0*KK+i1)*KK+i2)*KK+i3;
  j=((i1*KK+i2)*KK+i3)*KK+i4;
  if(barry[i0][i1][i2][i3][i4]=='Y') {
	dbtag[i]=1;
	dbtag[j]=1;
	lijnk(i,j,3);
	k++;
	}
  }
printf("nuclear size bpass6 = %10d\n",k);
}

/* THREE71.C */


/* end nxrijn71.c */
